import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["errorState", "onBlur", "onChange", "resize", "size", "state", "value"];
import PropTypes from 'prop-types';
import cx from 'classnames';
import { BASE_CLASS, DEFAULT_PROPS, TEXTAREA_RESIZES, TEXTAREA_SIZES, TEXTAREA_STATES } from './settings';
import { jsx as _jsx } from "react/jsx-runtime";

var AtomTextarea = function AtomTextarea(_ref) {
  var errorState = _ref.errorState,
      _ref$onBlur = _ref.onBlur,
      onBlur = _ref$onBlur === void 0 ? DEFAULT_PROPS.onBlur : _ref$onBlur,
      _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? DEFAULT_PROPS.onChange : _ref$onChange,
      resize = _ref.resize,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? DEFAULT_PROPS.size : _ref$size,
      state = _ref.state,
      value = _ref.value,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var className = cx(BASE_CLASS, BASE_CLASS + "--" + size, errorState && BASE_CLASS + "--" + TEXTAREA_STATES.ERROR, errorState === false && BASE_CLASS + "--" + TEXTAREA_STATES.SUCCESS, resize && BASE_CLASS + "--resize-" + resize, state && BASE_CLASS + "--" + state);

  var handleChange = function handleChange(ev) {
    var _ev$target = ev.target,
        value = _ev$target.value,
        name = _ev$target.name;
    onChange(ev, {
      value: value,
      name: name
    });
  };

  return /*#__PURE__*/_jsx("textarea", _extends({}, props, {
    onBlur: onBlur,
    onChange: handleChange,
    className: className,
    value: value
  }));
};

AtomTextarea.displayName = 'AtomTextarea';
export default AtomTextarea;
export { TEXTAREA_RESIZES as AtomTextareaResizes, TEXTAREA_SIZES as AtomTextareaSizes, TEXTAREA_STATES as AtomTextareaStates };